#Python3
#Author: Diana Montes-Grajales (03/03/2021)

import os
import pandas as pd
import numpy as np
import xlsxwriter

#glob.glob("./*.xlsx")

#Generate a dataframe (df) with the data of the excel file.
# The excel file can be downloaded from: https://drive.google.com/drive/folders/1HJjcQScB6DltotBzjSNHCUwTX5lE_Yol?usp=sharing


SERVER_df= pd.read_excel("./NetMHCIIpan_DRB1_FV02032021.xlsx")
WAF_df= pd.read_excel("./WAF_HLA_II.xlsx")

SERVER_NEW_df = pd.DataFrame(pd.merge(SERVER_df,WAF_df, on="HLA", how="inner" ))

#Counts of HLAs (Strong/Weak)
SERVER_df["HLA"]= pd.DataFrame(SERVER_df.groupby(["Peptide","Bind Level"], as_index=False)["HLA"].transform(lambda x : '/'.join(x)))
SERVER_df['Number of HLAs'] = SERVER_df.groupby(["Peptide","Bind Level"])['HLA'].transform('count').fillna(0)
SERVER_df = SERVER_df.drop_duplicates().pivot("Peptide","Bind Level").fillna(0) 

#Frequencies calculation
SERVER_NEW_df["HLA"]= pd.DataFrame(SERVER_NEW_df.groupby(["Peptide","Bind Level"], as_index=False)["HLA"].transform(lambda x : '/'.join(x)))
SERVER_NEW_df['Number of HLAs'] = SERVER_NEW_df.groupby(["Peptide","Bind Level"])['HLA'].transform('count').fillna(0)
#SERVER_NEW_df = SERVER_NEW_df.groupby(["HLA","Peptide","Number of HLAs","Bind Level","Gene"])["Freq_Mestizo", "Freq_Amerindians"].sum()
SERVER_NEW_df = pd.pivot_table(SERVER_NEW_df,index=["Peptide"], columns=["Gene"], values=["Freq_all","Freq_Mestizo","Freq_AfricanColombians","Freq_Amerindians","Freq_Bogota"],aggfunc=sum, fill_value=0)


SERVER_FINAL_df= pd.merge (SERVER_df,SERVER_NEW_df, "left", on=["Peptide"] )
#SERVER_df = SERVER_df.drop_duplicates().pivot("Peptide", "Bind Level").fillna(0)   


#print (SERVER_df)




#SERVER_NEW_df= pd.DataFrame(SERVER_NEW_df.groupby(["HLA","Peptide","Number of HLAs","Bind Level"], as_index=False)["Freq_Mestizo","Freq_Amerindians"].sum().fillna(0)).pivot("Peptide","Bind Level")  

print(SERVER_FINAL_df)
SERVER_FINAL_df.to_excel ("Results_HLA_II.xlsx", index=True, header=True)