#Python3
#Author: Diana Montes-Grajales (16/02/2021)

import os
import pandas as pd
import numpy as np
import xlsxwriter

#glob.glob("./*.xlsx")

#Generate a dataframe (df) with the data of the excel file.
# The excel file can be downloaded from: https://drive.google.com/drive/folders/1HJjcQScB6DltotBzjSNHCUwTX5lE_Yol?usp=sharing


LIST_top10= pd.read_excel("./Top_10.xlsx")
SERVER_top10= pd.read_excel("./Other_Interactions.xlsx")


#Counts of HLAs (Strong/Weak)
SERVER_top10["HLA"]= pd.DataFrame(SERVER_top10.groupby(["Peptide","Bind Level"], as_index=False)["HLA"].transform(lambda x : '/'.join(x)))
SERVER_top10['Number of HLAs'] = SERVER_top10.groupby(["Peptide","Bind Level"])['HLA'].transform('count').fillna(0)
SERVER_top10 = SERVER_top10.drop_duplicates().pivot("Peptide","Bind Level").fillna(0) 

#Merge
SERVER_COMPLETE_df = pd.DataFrame(pd.merge(LIST_top10,SERVER_top10, on="Peptide", how="inner" ))

print(SERVER_COMPLETE_df)
SERVER_COMPLETE_df.to_excel ("Top10_Number_of_Interactions.xlsx", index=True, header=True)